import 'package:string_converter/utf8/fromBinary.dart';
import 'package:string_converter/utf8/fromUTF.dart';

/// utf8
String utf8(String text) {
  try {
    /// if text length is 0
    if (text.length == 0) return "";

    /// check text pattern has match
    if (RegExp(r"^(0x|)[0-1]+").hasMatch(text)) {
      return fromBinary(text);
    } else if (RegExp(r"^(\\u|u+|)[a-z0-9 ]+").hasMatch(text)) {
      return fromUTF(text);
    }
    return null;
  } catch (_) {
    return null;
  }
}
