/// from binary to utf8
String fromBinary(String text) {
  /// replace text
  text = text
      .replaceAll("0x", " ")
      .replaceAll(r"\s+", " ")
      .replaceAll(r"^\s+", "")
      .replaceAll(r"\s+$", "")
      .trim();

  /// if text length is 0
  if (text.length == 0) return "";

  var chars = [];

  if (text.indexOf(" ") > 0) {
    /// text values are separated by space
    var bytes = text.split(" ");
    for (var i = 0; i < bytes.length; i++) {
      chars.add(String.fromCharCode(int.parse(bytes[i], radix: 2)));
    }
  } else {
    /// text values are one large blob of binary bits
    if (text.length < 8) {
      while (text.length < 8) {
        text = "0" + text;
      }
    }

    /// if text length % 8 != 0
    if (text.length % 8 != 0) {
      print("Can't Convert.");
      return "";
    }

    /// for loop and add to list
    for (var i = 0; i < text.length; i += 8) {
      chars.add(String.fromCharCode(int.parse(text.substring(i, 8), radix: 2)));
    }
  }

  /// return text
  return chars.join("");
}
