/// from utf16 & utf32 to utf8
String fromUTF(String text) {
  /// if text length is 0
  if (text.length == 0) {
    return "";
  }

  /// replace text
  var input = text
      .replaceAll(r"\u", " ")
      .replaceAll(r"u+", " ")
      .replaceAll(RegExp(r"^\s+"), "")
      .replaceAll(RegExp(r"\s+$"), "")
        ..replaceAll(r"\n+", " ")
        ..replaceAll(r"\t+", " ").toLowerCase();

  var ret = '';

  /// text split to list
  var gucciUtf = input.split(RegExp(r"\s+"));

  /// list for loop
  for (var i = 0; i < gucciUtf.length; i++) {
    /// get list value
    var utf16 = gucciUtf[i];

    /// if text length is 4
    if (utf16.length < 4) {
      /// while loop
      while (utf16.length < 4) {
        /// add 0 to text
        utf16 = "0" + utf16;
      }
    }

    /// convert to hex
    var code = int.parse(utf16, radix: 16);

    /// add to text
    ret += String.fromCharCode(code);
  }

  /// return text
  return ret;
}
